Package com.orchestranetworks.rest.util

# Interface URIBuilderForBuiltin<T extends URIBuilderForBuiltin<T>>

All Known Subinterfaces:
  `URIBuilderForBuiltin.ForDataAndHistory`, `URIBuilderForBuiltin.ForDataset<T>`, `URIBuilderForBuiltin.ForDataspace<T>`, `URIBuilderForBuiltin.ForNode<T>`, `URIBuilderForBuiltin.ForRecord<T>`, `URIBuilderForBuiltin.ForTable<T>`

public interface URIBuilderForBuiltin<T extends URIBuilderForBuiltin<T>>
Provides useful methods to generate a `URI` to EBX® built-in REST services.

Since:
  5.9.0
See Also:
  - `Constants`
  - `CategoryURIBuilder`
  - Data services documentation
  - Built-in REST services documentation

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Interface
  Description
  `static interface`
  `URIBuilderForBuiltin.ForDataAndHistory`
  Aggregates methods to generate built-in REST services `URI` to data and history category resources.
  `static interface`
  `URIBuilderForBuiltin.ForDataset<T extends URIBuilderForBuiltin<T>>`
  Contains methods to generate built-in REST services `URI` to a dataset.
  `static interface`
  `URIBuilderForBuiltin.ForDataspace<T extends URIBuilderForBuiltin<T>>`
  Beta feature: Contains methods to generate built-in REST services `URI` to a dataspace.
  `static interface`
  `URIBuilderForBuiltin.ForNode<T extends URIBuilderForBuiltin<T>>`
  Contains methods to generate built-in REST services `URI` to a record field or a dataset node.
  `static interface`
  `URIBuilderForBuiltin.ForRecord<T extends URIBuilderForBuiltin<T>>`
  Contains methods to generate built-in REST services `URI` to a record.
  `static interface`
  `URIBuilderForBuiltin.ForTable<T extends URIBuilderForBuiltin<T>>`
  Contains methods to generate built-in REST services `URI` to a table.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `URI`
  `build()`
  Returns an absolute `URI` that includes every previous configured URI's part.
  `T`
  `extendedAction(String anExtendedAction)`
  Appends the provided extended action to the generated URI path's end.
  `T`
  `firstPage()`
  Replaces the first page action from the existing set of query parameters.
  `T`
  `lastPage()`
  Replaces the last page action from the existing set of query parameters.
  `T`
  `nextPage(String aPageRecordFilter)`
  Replaces the next page action and page record filter from the existing set of query parameters.
  `T`
  `pageSize(int aPageSize)`
  Replaces the provided pageSize from the existing set of query parameters.
  `T`
  `previousPage(String aPageRecordFilter)`
  Replaces the previous page action and page record filter from the existing set of query parameters.
  `T`
  `queryParams(MultivaluedMap<String,String> parameters)`
  Appends the provided query parameters to the existing set of query parameters.
  `T`
  `queryParams(Map<String,String> parameters)`

- ## Method Details

  - ### queryParams

    T queryParams(Map<String,String> parameters)
    See Also:
      - `queryParams(MultivaluedMap)`

  - ### queryParams

    T queryParams(MultivaluedMap<String,String> parameters)
    Appends the provided query parameters to the existing set of query parameters.
    Parameters:
      `parameters` - the query parameters to add to the existing set.
    Returns:
      the updated URI Builder.
    Since:
      6.1.2
    See Also:
      - `UriBuilder.queryParam(String, Object...)`

  - ### pageSize

    T pageSize(int aPageSize)
    Replaces the provided pageSize from the existing set of query parameters.
    Parameters:
      `aPageSize` - the size of the returned page.
    Returns:
      the updated URI builder.
    Since:
      6.0.0
    See Also:
      - `UriBuilder.replaceQueryParam(String, Object...)`

  - ### firstPage

    T firstPage()
    Replaces the first page action from the existing set of query parameters.

    If a page record filter is found, it is deleted.

    Returns:
      the updated URI builder.
    Since:
      6.0.0
    See Also:
      - `UriBuilder.replaceQueryParam(String, Object...)`

  - ### lastPage

    T lastPage()
    Replaces the last page action from the existing set of query parameters.

    If a page record filter is found, it is deleted.

    Returns:
      the updated URI builder.
    Since:
      6.0.0
    See Also:
      - `UriBuilder.replaceQueryParam(String, Object...)`

  - ### nextPage

    T nextPage(String aPageRecordFilter)
    Replaces the next page action and page record filter from the existing set of query parameters.
    Parameters:
      `aPageRecordFilter` - a record XPath predicate expression used to determine the pagination contexts. It should not be modified on the client side.
    Returns:
      the updated URI builder.
    Since:
      6.0.0
    See Also:
      - `UriBuilder.replaceQueryParam(String, Object...)`

  - ### previousPage

    T previousPage(String aPageRecordFilter)
    Replaces the previous page action and page record filter from the existing set of query parameters.
    Parameters:
      `aPageRecordFilter` - a record XPath predicate expression used to determine the pagination contexts. It should not be modified on the client side.
    Returns:
      the updated URI builder.
    Since:
      6.0.0
    See Also:
      - `UriBuilder.replaceQueryParam(String, Object...)`

  - ### extendedAction

    T extendedAction(String anExtendedAction)
    Appends the provided extended action to the generated URI path's end.

    Warning: When this API is run, the extended action is appended to the currently configured URI's path.

    Parameters:
      `anExtendedAction` - the extended action to append. If the provided value is not prefaced with the character `:`, then it is automatically added.
    Returns:
      the updated URI builder.
    Since:
      6.0.0

  - ### build

    URI build()
    Returns an absolute `URI` that includes every previous configured URI's part.
    See Also:
      - URL definition